=== debian/changelog ===
bluez-btsco (1:0.50-0ubuntu7) disco; urgency=medium

  * Modernize packaging using dh sequencer and 3.0 quilt format.
  * Bump Standards-Version to 4.3.0.
  * Bump debhelper compat version to 11, fixing FTBFS.
  * Drop unnecessary change to configure.in.
  * d/p/fix-index-path.diff: Record README change as quilt patch.

 -- Logan Rosen <logan@ubuntu.com>  Sun, 06 Jan 2019 22:01:40 -0500

bluez-btsco (1:0.50-0ubuntu6) wily; urgency=medium

  * debian/control: Build-Depends on automake, not 1.9

 -- Sebastien Bacher <seb128@ubuntu.com>  Mon, 05 Oct 2015 15:52:16 +0200

bluez-btsco (1:0.50-0ubuntu5) wily; urgency=medium

  * debian/control: depends on bluez rather than bluez-utils

 -- Sebastien Bacher <seb128@ubuntu.com>  Thu, 13 Aug 2015 18:24:06 +0200

bluez-btsco (1:0.50-0ubuntu4) quantal; urgency=low

  * debian/control: Added Homepage Field and Added ${misc:Depends} to Depends 
    since package uses Debhelper 

 -- Benjamin Kerensa <bkerensa@ubuntu.com>  Sun, 23 Sep 2012 23:53:01 -0700

bluez-btsco (1:0.50-0ubuntu3) intrepid; urgency=low

  * No-change rebuild for libbluetooth2 -> libbluetooth3 transistion.

 -- Steve Kowalik <stevenk@ubuntu.com>  Wed, 08 Oct 2008 12:56:18 +1100

bluez-btsco (1:0.50-0ubuntu2) feisty; urgency=low

  * Fixes index.html path in README (LP: #82872)

 -- Luca Falavigna <dktrkranz@ubuntu.com>  Fri, 23 Mar 2007 22:03:44 +0100

bluez-btsco (1:0.50-0ubuntu1) feisty; urgency=low

  * New upstream release.
  * configure.in:
    - replaced AC_PROG_RANLIB with AC_PROG_LIBTOOL
  * debian/applied-patches/add_ac_prog_libtool.diff:
    - removed
  * debian/control:
    - automake1.7 --> automake1.9
    - added libao-dev to Build-Depends
  * debian/docs:
    - include upstream documentation
  * debian/rules:
    - invoke autoreconf instead of bootstap script
    - build using --enable-all

 -- Matti Lindell <mlind@cs.joensuu.fi>  Sat, 20 Jan 2007 13:35:36 +0200

bluez-btsco (1:0.42-0ubuntu1) edgy; urgency=low

  * New upstream release.
  * debian/applied-patches/add_ac_prog_libtool.diff:
    - added AC_PROG_LIBTOOL to configure.in (and ran aclocal and autoconf
      afterwards).
  * debian/control:
    - added libtool to Build-Depends.

 -- Daniel Holbach <daniel.holbach@ubuntu.com>  Fri, 13 Oct 2006 11:14:34 +0200

bluez-btsco (14112005cvs-2build1) edgy; urgency=low

  * rebuild for libbluetooth1 -> libbluetooth2 soname change

 -- Michael Bienia <michael@vorlon.ping.de>  Sun,  3 Sep 2006 13:43:12 +0200

bluez-btsco (14112005cvs-2) dapper; urgency=low

  * Depend on automake tools 

 -- Charles Majola <charles@ubuntu.com>  Fri,  9 Dec 2005 08:33:13 +0000

bluez-btsco (14112005cvs-1) dapper; urgency=low

  * Initial release Closes: Ubuntu #11997

 -- Charles Majola <charles@ubuntu.com>  Mon, 14 Nov 2005 11:36:50 +0000
