=== debian/control ===
Source: bluez-btsco
Section: sound
Priority: optional
Maintainer: Charles Majola <charles@ubuntu.com>
Build-Depends: debhelper (>= 11~), libbluetooth-dev, libasound2-dev, libao-dev
Standards-Version: 4.3.0
Homepage: http://bluetooth-alsa.sourceforge.net/

Package: bluez-btsco
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, bluez
Description: Bluez Bluetooth SCO tool
 A tool to that provides a way to use a bluetooth headset with Linux.
 It works well enough now to get voice-quality audio to and from most 
 headsets
